/*
 *
 ******************************* Creazione file *******************************
 *-------------------------------------|--------------------------------------*
 * Creatore : Marco Savegnago             	Data di creazione : 21/1/01
 * Codice   :
 *
 *
 ******************************* Revisione file *******************************
 *-------------------------------------|--------------------------------------*
 * Revisore : 								Data di revisione :
 * Versione :
 *
 * Note:
 *
 */

#ifndef	__BARCODEITEMQUEUE_H
#define	__BARCODEITEMQUEUE_H

#include	"win32\thread.h"

/******************************** Definizioni *********************************
*--------------------------------------|--------------------------------------*/

/*************************** Dichiarazione dei tipi ***************************
*--------------------------------------|--------------------------------------*/

const	ci_BARCODEQUEUEITEMMAXCODELEN	=	128;


const	BCS_NONE		=	0;
const	BCS_ENTERING		=	1;
const	BCS_TESTING		=	2;
const	BCS_COOKING		=	3;
const	BCS_FAULT		=	4;
const	BCS_EXITED		=	5;

/********************************** TBarcodeItem *******************************
*--------------------------------------|--------------------------------------*/

struct	TBarcodeQItem
{
	BYTE			pby_code[ci_BARCODEQUEUEITEMMAXCODELEN];
	DWORD			dw_time;
	BYTE			by_status;
	BOOL			b_okflag;
	BOOL			b_koflag;

	TBarcodeQItem*	next;

	bool	operator	==	(const	TBarcodeQItem&	other)
	{
		if(memcmp(pby_code, other.pby_code, ci_BARCODEQUEUEITEMMAXCODELEN))
			return	false;
		
		return	true;
	}

	bool	operator	!=	(TBarcodeQItem*	other)
	{
		if(memcmp(pby_code, other->pby_code, ci_BARCODEQUEUEITEMMAXCODELEN))
			return	true;
		
		return	false;
	}

	bool	IsEqual(TBarcodeQItem*	other)
	{
		if(memcmp(pby_code, other->pby_code, ci_BARCODEQUEUEITEMMAXCODELEN))
			return	false;
		
		return	true;
	}

	TBarcodeQItem()
	{
		memset(this, 0, sizeof(*this));
	}
};

const	ci_BARCODEQUEUEHEADERLEN	=	6;

struct	TBarcodeQQueue 
:
	private TSync
{
	TEventSemaphore		event;
	TBarcodeQItem*		head;
	TBarcodeQItem*		tail;
	DWORD				dw_count;

	TBarcodeQQueue()
	{
		head		=	tail	=	NULL;
		dw_count	=	0;
	}

	~TBarcodeQQueue()
	{
		Flush();
	}

	bool			Insert(const TBarcodeQItem& item);
	bool			Remove(TBarcodeQItem& item);
	bool			PeekHead(TBarcodeQItem& item);
	bool			Find(const	TBarcodeQItem& item, BYTE by_Status, BOOL b_Remove=FALSE);
	void			Flush();
	int			GetCount();
	TBarcodeQItem*		findPrev(TBarcodeQItem* item);
	void			Detach(TBarcodeQItem* toDetach);
	bool			ChangeTail(const	TBarcodeQItem& item);
	bool			ChangeHead(const	TBarcodeQItem& item);

	static	char		sz_fileHeader[];
	bool			writeHeader(FILE* file);
	bool			checkHeader(FILE* file);

	void	ForEach( void (*ccAppFunc)( const	TBarcodeQItem* item, void * ), void *arg );

	bool	LoadFromFile(char*	sz_filename, bool	b_flushPreviuos=true);
	bool	WriteToFile(char*	sz_filename);
};



/************************* Variabili globali esterne **************************
*--------------------------------------|--------------------------------------*/

/************************** Prototipi delle funzioni **************************
*--------------------------------------|--------------------------------------*/

/*********************************** Macro ************************************
*--------------------------------------|--------------------------------------*/

#endif	//	#define	__BARCODEITEMQUEUE_H
